package code;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.net.URLDecoder;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.KeyManagerFactory;
import java.security.KeyStore;
import javax.net.ssl.TrustManagerFactory;
import org.bouncycastle.openssl.PEMEncryptedKeyPair;
import org.bouncycastle.openssl.PEMKeyPair;
import org.bouncycastle.openssl.jcajce.JcaPEMKeyConverter;
import org.bouncycastle.openssl.jcajce.JcePEMDecryptorProviderBuilder;
import org.bouncycastle.openssl.PEMParser;
import java.io.FileReader;
import java.io.FileInputStream;
import java.security.cert.X509Certificate;
import javax.net.ssl.SSLContext;
import java.security.cert.CertificateFactory;
import java.io.BufferedInputStream;
import java.security.Security;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.openssl.PEMDecryptorProvider;
import java.security.KeyPair;

import org.json.JSONException;

import com.sun.net.httpserver.Headers;
import com.sun.net.httpserver.HttpsExchange;

public class Helper {

	private static String keycloakRealm = "test00";
	private static String keycloakURL = "http://localhost:8080/";
	private static String cloudappURL = "https://localhost:3002/";
	private static String selfURL = "https://localhost:3001";

	public static void sendCors(HttpsExchange exchange, int stato, String response) throws IOException {
		Headers headers = exchange.getResponseHeaders();
		headers.add("Access-Control-Allow-Origin", "*");// se non mettiamo *, viene errore CORS //http://localhost:3001/secured/domains
		headers.add("Access-Control-Allow-Methods", "GET, POST, OPTIONS");
		headers.add("Access-Control-Allow-Headers", "Content-Type,Authorization");
		if(response == null){
			exchange.sendResponseHeaders(stato, -1);
			return;
		}
		byte[] responseBytes = response.getBytes();
		exchange.sendResponseHeaders(200, responseBytes.length);
		OutputStream os = exchange.getResponseBody();
		os.write(responseBytes);
		os.close();
	}

	public static void sendCors(HttpsExchange exchange, int stato) throws IOException {
		sendCors(exchange, stato, null);
	}

	public static void sendCors(HttpsExchange exchange, String response) throws IOException {
		sendCors(exchange, 200, response);
	}

	public static String checkTokenGetUser(HttpsExchange exchange) {
		String token = exchange.getRequestHeaders().get("Authorization").get(0).substring(7);// taglio bearer
		String[] tokSplit = token.split("[.]");
		if(tokSplit.length != 3) return null;
		String signature = tokSplit[2];
		try {
			return TokenHandler.verificaToken(token, signature);
		} catch (NoSuchAlgorithmException | IOException | JSONException e) {
			e.printStackTrace();
			return null;
		}
	}

	public static Map<String, Object> parseQuery(String query) throws UnsupportedEncodingException {
		if(query == null) throw new IllegalArgumentException("Query string can't be null");

		Map<String, Object> result = new HashMap<String, Object>();
		String pairs[] = query.split("[&]");
		for (String pair : pairs) {
			String param[] = pair.split("[=]");
			String key = null;
			String value = null;
			if (param.length > 0) {
				key = URLDecoder.decode(param[0], System.getProperty("file.encoding"));
			}

			if (param.length > 1) {
				value = URLDecoder.decode(param[1], System.getProperty("file.encoding"));
			}

			if (result.containsKey(key)) {
				Object obj = result.get(key);
				if (obj instanceof List<?>) {
					@SuppressWarnings("unchecked")
					List<String> values = (List<String>) obj;
					values.add(value);
				} else if (obj instanceof String) {
					List<String> values = new ArrayList<String>();
					values.add((String) obj);
					values.add(value);
					result.put(key, values);
				}
			} else {
				result.put(key, value);
			}
		}
		return result;
	}

	public static String readBody(InputStream requestBody) {
		int request;
		StringBuffer response = new StringBuffer();
		try {
			while ((request = requestBody.read()) != -1)
				response.append(Character.toString((char) request));
		} catch (IOException e) {
			e.printStackTrace();
		}
		return response.toString();
	}

	public static HttpsURLConnection sendMessageToCloudapp(String path, String message) throws IOException {
		try {
			URL url = new URL(getCloudappURL() + (path.startsWith("/") ? path.substring(1) : path));
			System.out.println(url);
			HttpsURLConnection connection = (HttpsURLConnection) url.openConnection();
			// set the connection to work with SSL
			connection.setSSLSocketFactory(getSocketFactory());

			// SSLContext context = getSSLContext();
			// SSLEngine engine = context.createSSLEngine();
			// params.setNeedClientAuth(false);
			// params.setCipherSuites(engine.getEnabledCipherSuites());
			// params.setProtocols(engine.getEnabledProtocols());

			// 			// Set the SSL parameters
			// SSLParameters sslParameters = context.getSupportedSSLParameters();
			// params.setSSLParameters(sslParameters);


			// connection.
			/* //mio test
			-Djavax.net.ssl.keyStoreType=pkcs12
			-Djavax.net.ssl.trustStoreType=jks
			-Djavax.net.ssl.keyStore=clientcertificate.p12
			-Djavax.net.ssl.trustStore=gridserver.keystore
			-Djavax.net.debug=ssl # very verbose debug
			-Djavax.net.ssl.keyStorePassword=$PASS
			-Djavax.net.ssl.trustStorePassword=$PASS
			System.setProperty("javax.net.ssl.keyStoreType", "pkcs12");
			System.setProperty("javax.net.ssl.keyStore", "../lig.keystore");
			System.setProperty("javax.net.ssl.keyStorePassword", "miapasswd");
			System.setProperty("javax.net.ssl.trustStore", "../lig.keystore");
			System.setProperty("javax.net.ssl.trustStorePassword", "miapasswd");
			System.setProperty("javax.net.debug", "ssl");
			*/

			setConnectionSettings(connection,"POST");
			connection.connect(); //non serve perche' getOutputStream() fa gia' la connect
			OutputStream out = connection.getOutputStream();//FIXME: qui si blocca con https
			// DataOutputStream outStream = new DataOutputStream(out);//inserimento param in call
			System.out.println("Sending message: " + message);
			// outStream.write(message.getBytes());
			out.write(message.getBytes());
			// outStream.flush();
			// outStream.close();
			out.close();
			return connection;
		} catch (Exception e) {
			//HERE remove this test
			e.printStackTrace();
			return null;
		}
	}

	// static {// => non funziona il messaggio inviato alla fine (sun.net.httpserver.FixedLengthInputStream@1377edd2)
	//     //for localhost testing only
	//     javax.net.ssl.HttpsURLConnection.setDefaultHostnameVerifier(
	//     new javax.net.ssl.HostnameVerifier(){
	// 		//https://mkyong.com/webservices/jax-ws/java-security-cert-certificateexception-no-name-matching-localhost-found/
	// 		//http://java.globinch.com/enterprise-java/security/fix-java-security-certificate-exception-no-matching-localhost-found/
	//         public boolean verify(String hostname, javax.net.ssl.SSLSession sslSession) {
	// 			System.out.println("hostname: " + hostname);
	// 			System.out.println("sslSession: " + sslSession);
	//             return hostname.equals("localhost");
	//         }
	//     });
	// }

	private static SSLSocketFactory getSocketFactory(/*final String caCrtFile, final String crtFile, final String keyFile, final String password*/) throws Exception {
		/*String caCrtFile = "../certificates/localhost/caWebServer.crt";
		String crtFile = "../certificates/localhost/server.crt";
		String keyFile = "../certificates/localhost/server.key";
		String password = "miapasswd";

		Security.addProvider(new BouncyCastleProvider());

		// load CA certificate
		X509Certificate caCert = null;

		FileInputStream fis = new FileInputStream(caCrtFile);
		BufferedInputStream bis = new BufferedInputStream(fis);
		CertificateFactory cf = CertificateFactory.getInstance("X.509");

		while (bis.available() > 0) {
			caCert = (X509Certificate) cf.generateCertificate(bis);
		}

		// load client certificate
		bis = new BufferedInputStream(new FileInputStream(crtFile));
		X509Certificate cert = null;
		while (bis.available() > 0) {
			cert = (X509Certificate) cf.generateCertificate(bis);
		}

		// load client private key
		PEMParser pemParser = new PEMParser(new FileReader(keyFile));
		Object object = pemParser.readObject();
		PEMDecryptorProvider decProv = new JcePEMDecryptorProviderBuilder()
				.build(password.toCharArray());
		JcaPEMKeyConverter converter = new JcaPEMKeyConverter()
				.setProvider("BC");
		KeyPair key;
		if (object instanceof PEMEncryptedKeyPair) {
			//System.out.println("Encrypted key - we will use provided password");
			key = converter.getKeyPair(((PEMEncryptedKeyPair) object)
					.decryptKeyPair(decProv));
		} else {
			//System.out.println("Unencrypted key - no password needed");
			key = converter.getKeyPair((PEMKeyPair) object);
		}
		pemParser.close();

		// CA certificate is used to authenticate server
		KeyStore caKs = KeyStore.getInstance(KeyStore.getDefaultType());
		caKs.load(null, null);
		caKs.setCertificateEntry("ca-certificate", caCert);
		TrustManagerFactory tmf = TrustManagerFactory.getInstance("X509");
		tmf.init(caKs);

		// client key and certificates are sent to server so it can authenticate
		// us
		KeyStore ks = KeyStore.getInstance(KeyStore.getDefaultType());
		ks.load(null, null);
		ks.setCertificateEntry("certificate", cert);
		ks.setKeyEntry("private-key", key.getPrivate(), password.toCharArray(),
				new java.security.cert.Certificate[] { cert });
		KeyManagerFactory kmf = KeyManagerFactory.getInstance(KeyManagerFactory
				.getDefaultAlgorithm());
		kmf.init(ks, password.toCharArray());

		// finally, create SSL socket factory
		SSLContext context = SSLContext.getInstance("TLSv1.2");
		context.init(kmf.getKeyManagers(), tmf.getTrustManagers(), null);

		return context.getSocketFactory();*/

		SSLContext sslContext = SSLContext.getInstance("TLS");

		// initialise the keystore
		char[] password = "miapasswd".toCharArray();
		KeyStore ks = KeyStore.getInstance("JKS");
		FileInputStream fis = new FileInputStream("../certificates/localhost/lig.keystore");
		ks.load(fis, password);

		// setup the key manager factory
		KeyManagerFactory kmf = KeyManagerFactory.getInstance("SunX509");
		kmf.init(ks, password);

		// setup the trust manager factory
		TrustManagerFactory tmf = TrustManagerFactory.getInstance("SunX509");
		tmf.init(ks);

		// setup the HTTPS context and parameters
		sslContext.init(kmf.getKeyManagers(), tmf.getTrustManagers(), null);

		return sslContext.getSocketFactory();
	}

	public static void setConnectionSettings(HttpsURLConnection connection, String method) throws IOException{
		connection.setRequestMethod(method);
		connection.setRequestProperty("Content-Type", "application/json");
		connection.setRequestProperty("Accept", "application/json");
		connection.setDoOutput(true);
		connection.setConnectTimeout(5000);
		connection.setReadTimeout(5000);
	}

	public static String getResponseFromConnection(HttpsURLConnection con) throws IOException {
		BufferedReader reader = new BufferedReader(new InputStreamReader(con.getInputStream()));
		String inputLine;
		StringBuffer content = new StringBuffer();
		while ((inputLine = reader.readLine()) != null) {
			content.append(inputLine);
		}
		reader.close();
		return content.toString();
	}

	public static String getKeycloakRealm(){
		return keycloakRealm;
	}

	public static String getKeycloakURL(){
		return keycloakURL;
	}

	public static String getCloudappURL(){
		return cloudappURL;
	}

	public static String getSelfURL(){
		return selfURL;
	}

}
